/*
 * 会员卡领取记录
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class UserCardRecordController : BaseController
    {
        public UserCardRecordController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
        }

        #region 会员卡领取记录列表

        /// <summary>
        /// 根据条件查询会员卡领取记录列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(UserCardRecord data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            
            return View();
        }

        #endregion

        #region 根据条件查询会员卡领取记录列表

        /// <summary>
        /// 会员卡领取记录列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(UserCardRecord data, string ConsumerIdNickName, string ConsumerIdMobile, string CardIdBrandName, string CardIdTitle, int page = 1, int limit = 30)
        {
            
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            
            Fields.Add("CreateDate", "3"); //时间


            string condition = " and Status>-1";
            //消费者昵称
if (!string.IsNullOrEmpty(ConsumerIdNickName))
{
condition += " and ConsumerId in (select ConsumerId from ConsumersForNickName where NickName='" + ConsumerIdNickName + "')";
}
//消费者手机号
if (!string.IsNullOrEmpty(ConsumerIdMobile))
{
condition += " and ConsumerId in (select ConsumerId from ConsumersForMobile where Mobile='" + ConsumerIdMobile + "')";
}
//会员卡商户名字
if (!string.IsNullOrEmpty(CardIdBrandName))
{
condition += " and CardId in (select CardId from UserCardForWeChatForBrandName where BrandName='" + CardIdBrandName + "')";
}
//会员卡卡券名
if (!string.IsNullOrEmpty(CardIdTitle))
{
condition += " and CardId in (select CardId from UserCardForWeChatForTitle where Title='" + CardIdTitle + "')";
}


            Dictionary<string, object> obj = new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).IndexData("UserCardRecord", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //消费者
int ConsumerId = int.Parse(function.CheckInt(dic["ConsumerId"].ToString()));
Consumers consumerid_Consumers = db.Consumers.FirstOrDefault(m => m.Id == ConsumerId) ?? new Consumers();
dic["ConsumerIdNickName"] = consumerid_Consumers.NickName;
dic["ConsumerIdMobile"] = consumerid_Consumers.Mobile;
dic.Remove("ConsumerId");
//会员卡
int CardId = int.Parse(function.CheckInt(dic["CardId"].ToString()));
UserCardForWeChat cardid_UserCardForWeChat = db.UserCardForWeChat.FirstOrDefault(m => m.Id == CardId) ?? new UserCardForWeChat();
dic["CardIdBrandName"] = cardid_UserCardForWeChat.BrandName;
dic["CardIdTitle"] = cardid_UserCardForWeChat.Title;
dic.Remove("CardId");

            }
            return Json(obj);
        }

        #endregion

        #region 增加会员卡领取记录

        /// <summary>
        /// 增加或修改会员卡领取记录信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            return View();
        }

        #endregion

        #region 增加会员卡领取记录

        /// <summary>
        /// 增加或修改会员卡领取记录信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(UserCardRecord data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            
            
            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).Add("UserCardRecord", Fields, 0);
            AddSysLog(data.Id.ToString(), "UserCardRecord", "add");
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 修改会员卡领取记录

        /// <summary>
        /// 增加或修改会员卡领取记录信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            UserCardRecord editData = db.UserCardRecord.FirstOrDefault(m => m.Id == Id) ?? new UserCardRecord();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改会员卡领取记录

        /// <summary>
        /// 增加或修改会员卡领取记录信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(UserCardRecord data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            
            
            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserCardRecord", Fields, data.Id);
            AddSysLog(data.Id.ToString(),"UserCardRecord","update");
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 删除会员卡领取记录信息

        /// <summary>
        /// 删除会员卡领取记录信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"UserCardRecord","del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserCardRecord", Fields, id);
            }
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"UserCardRecord","open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserCardRecord", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"UserCardRecord","close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserCardRecord", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).Sort("UserCardRecord", Sort, Id);
            
            AddSysLog(Id.ToString(), "UserCardRecord", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count;i++ )
            {
                JsonData dr = list[i];
                
                db.UserCardRecord.Add(new UserCardRecord()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,
                    
                });
                db.SaveChanges();
            }
            AddSysLog("0", "UserCardRecord", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(UserCardRecord data, string ConsumerIdNickName, string ConsumerIdMobile, string CardIdBrandName, string CardIdTitle)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("CreateDate", "3"); //时间


            string condition = " and Status>-1";
            //消费者昵称
if (!string.IsNullOrEmpty(ConsumerIdNickName))
{
condition += " and ConsumerId in (select ConsumerId from ConsumersForNickName where NickName='" + ConsumerIdNickName + "')";
}
//消费者手机号
if (!string.IsNullOrEmpty(ConsumerIdMobile))
{
condition += " and ConsumerId in (select ConsumerId from ConsumersForMobile where Mobile='" + ConsumerIdMobile + "')";
}
//会员卡商户名字
if (!string.IsNullOrEmpty(CardIdBrandName))
{
condition += " and CardId in (select CardId from UserCardForWeChatForBrandName where BrandName='" + CardIdBrandName + "')";
}
//会员卡卡券名
if (!string.IsNullOrEmpty(CardIdTitle))
{
condition += " and CardId in (select CardId from UserCardForWeChatForTitle where Title='" + CardIdTitle + "')";
}


            Dictionary<string, object> obj = new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).IndexData("UserCardRecord", Fields, "Id desc", "0", 1, 20000, condition, "", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //消费者
int ConsumerId = int.Parse(function.CheckInt(dic["ConsumerId"].ToString()));
Consumers consumerid_Consumers = db.Consumers.FirstOrDefault(m => m.Id == ConsumerId) ?? new Consumers();
dic["ConsumerIdNickName"] = consumerid_Consumers.NickName;
dic["ConsumerIdMobile"] = consumerid_Consumers.Mobile;
dic.Remove("ConsumerId");
//会员卡
int CardId = int.Parse(function.CheckInt(dic["CardId"].ToString()));
UserCardForWeChat cardid_UserCardForWeChat = db.UserCardForWeChat.FirstOrDefault(m => m.Id == CardId) ?? new UserCardForWeChat();
dic["CardIdBrandName"] = cardid_UserCardForWeChat.BrandName;
dic["CardIdTitle"] = cardid_UserCardForWeChat.Title;
dic.Remove("CardId");

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            
            result.Add("Fields", ReturnFields);
            AddSysLog("0", "UserCardRecord", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
